'use strict';

const async = require('async');
const vk = new (require('vk-io'));
vk.setting({
	app: 5562610,
	phone: '', // Номер телефона вида 749531116869
	pass: '' // Пароль
});

const auth = vk.standloneAuth();

auth.run()
.then((token) => {
	console.log('Token:',token);

	vk.setToken(token);

	return true;
})
.then(() => {
	return vk.stream.fave.getPhotos();
})
.then((likes) => {
	console.log('Кол-во лайкнутых фотографий:',likes.length);

	return removeLike('photo',likes);
})
.then(() => {
	return vk.stream.fave.getPosts({
		extended: 0
	});
})
.then((likes) => {
	console.log('Кол-во лайкнутых постов:',likes.length);

	return removeLike('post',likes);
})
.then(() => {
	return vk.stream.groups.get({
		extended: 0
	});
})
.then((groups) => {
	return eachList(groups,(group,next) => {
		vk.api.groups.leave({
			group_id: group
		})
		.then(() => {
			console.log('Была покинута группа club'+group);

			next();
		})
		.catch(() => {
			console.log('Не удалось покинуть группу club'+group);

			next();
		});
	});
})
.then(() => {
	console.log('Чистка завершена!');
})
.catch((error) => {
	console.log('Произошла серьезная ошибка!',error);
});


/**
 * Удаляет лайк по типу
 *
 * @param string type
 * @param array  list
 *
 * @return promise
 */
function removeLike (type,list) {
	return eachList(list,(like,next) => {
		vk.api.likes.delete({
			type: type,
			item_id: like.id,
			owner_id: like.owner_id
		})
		.then(() => {
			console.log('Лайк',type+like.owner_id+'_'+like.id,'удалён!');

			next();
		})
		.catch(() => {
			console.log('Не удалось удалить лайк!',type+like.owner_id+'_'+like.id);

			next();
		});
	});
}

/**
 * Удаляет объект
 *
 * @param array  list
 *
 * @return promise
 */
function eachList (list,callback) {
	return new Promise((resolve) => {
		async.each(
			list,
			callback,
			(error) => {
				if (!error) {
					resolve();
				}
			}
		)
	});
}
